#include <bits/stdc++.h>
using namespace std;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, k; cin>>n>>k;
    vector <int> niz(k), niz1(k);
    for (int i=0; i<k; i++)
    {
        cin>>niz[i];
        niz1[i]=niz[i];
    }
    sort (niz1.begin(), niz1.end());
    map <int, int> mapa;
    for (int i=k-1; i>=0; i--)
    {
        int xorrez=0;
        for (int j=0; j<=i; j++)
        {
            if (niz1[i]%niz1[j]==0) xorrez^=niz1[j];
        }
        mapa[niz1[i]]=xorrez;
    }
    for (int i=0; i<k; i++)
    {
        cout<<mapa[niz[i]]<<" ";
    }
    cout<<'\n';
    return 0;
}